<?php
/*
Plugin Name: Elche_grabber
Plugin URI: http://elchepunebrek.ru/plagin-grabber-dlya-wp.html
Description: Грабер новостей с newsland.ru
Version: 0.1
Author: Elchepunebrek
Author URI: http://elchepunebrek.ru/   test
*/
define('ELCHE_GRAB_PATCH', plugin_dir_url( __FILE__ ));
wp_register_style('elche_grab_style.css', ELCHE_GRAB_PATCH . 'css/elche_grab_style.css');
wp_enqueue_style('elche_grab_style.css');
set_time_limit(0);


function elche_grab_options_page()
  {
  ?><div class="wrap"><h2>Настройки Elche Grabber 0.1</h2></div><br><br><?php
  if (isset($_REQUEST['BElcheGrabberSave']))
    {
    update_option('ElcheGrabberRssUrl', $_REQUEST['FElcheGrabberRssUrl']);
    update_option('ElcheGrabberUserName', $_REQUEST['FElcheGrabberUserName']);
    update_option('ElcheGrabberCat', $_REQUEST['FElcheGrabberCat']);
    update_option('ElcheGrabberTime', $_REQUEST['FElcheGrabberTime']);
    update_option('ElcheGrabberImgPatch', $_REQUEST['FElcheGrabberImgPatch']);
    echo '<div class="updated"><p>Настройки обновлены.</p></div>';
    }
  if (isset($_REQUEST['test']))
    {
    elche_grab_check();
    //elche_grab_get_content('http://www.newsland.ru/news/detail/id/661252/cat/100/');
    //elche_grab_get_authorid('news');
    }
  if (isset($_REQUEST['BElcheGrabberStart']))
    {
    elche_grab_setcron();
    }
  if (get_option('ElcheGrabberTime')!='')
  {$deftime=get_option('ElcheGrabberTime');}else{$deftime='hourly';}
  ?>

  <form action="" method=post>
  <div id="EG_settings">
  URL адрес RSS ленты (например http://newsland.ru/exp/rss/news/cat/100/)<br>
  <input type="text" name="FElcheGrabberRssUrl" value="<?=get_option('ElcheGrabberRssUrl');?>">
  </div>

  <div id="EG_settings">
  Пользователь от имени которого грабер будет вставлять записи<br>
  <input type="text" name="FElcheGrabberUserName" value="<?=get_option('ElcheGrabberUserName');?>"><br>
  </div>

  <div id="EG_settings">
  ID категории в которую вставлять новости<br>
  <input type="text" name="FElcheGrabberCat" value="<?=get_option('ElcheGrabberCat');?>"><br>
  </div>

  <div id="EG_settings">
  Периодичность запуска (Только эти значения: hourly - раз в час, twicedaily - раз в 12 часов, daily - раз в день)<br>

  <input type="text" name="FElcheGrabberTime" value="<?=$deftime;?>">
  </div>

  <div id="EG_settings">
  Папка для картинок (начиная с ../wp-content/, первый и последний слеши не ставятся!
  <br>Уже должна быть создана, и права выставлены в 777)<br>
  <input type="text" name="FElcheGrabberImgPatch" value="<?=get_option('ElcheGrabberImgPatch');?>">
  </div>

  <div id="EG_settings">
  <input type="submit" value="Сохранить настройки" name="BElcheGrabberSave"><br>
  <input type="submit" value="Начать работу" name="BElcheGrabberStart"><br>
  <input type="hidden" value="Test" name="test"><br>
  </div>
  </form>
  <?php
  }
/////////////////////////////////////////////////////////////////////////////

function elche_grab_check()
  {
  global $wpdb;
  $rssurl=get_option('ElcheGrabberRssUrl');
  $authorid=elche_grab_get_authorid(trim(get_option('ElcheGrabberUserName')));

  $selfsiteurl=str_replace('http://','',get_option('siteurl'));
  $selfsiteurl=str_replace('www','',$selfsiteurl);
  if ($rssurl!='')
    {
    $rss=simplexml_load_file($rssurl);
    foreach ($rss->channel->item as $item)
      {

       $title=trim($item->title);
       //print $title.'<br>';
       $allpost=$wpdb->get_row("select * from $wpdb->posts where post_author='$authorid' and post_title='$title' and post_status='publish'");
       if (empty($allpost))
        {
        $content=elche_grab_get_content($item->link);

        if (!stristr($content['ist'],$selfsiteurl))
          {
          }
          else
            {
            print '<div class="updated"><p><b>'.$title.'</b> не публикуется, т.к. источник указан - '.$content['ist'].'</p></div>';
            }



        if (strlen($content['text'])<5) {continue;}
        $img=elche_grab_save_img($item->enclosure['url']);

        $post = array(
                      'post_type'=>'post',
                      'post_author' =>$authorid,
                      'post_status' => 'publish',
                      'post_title'=>$title,
                      'post_category' =>array(get_option('ElcheGrabberCat')),
                      'post_date' =>date("Y-m-d H:i:s",strtotime($item->pubDate)),
                      'post_content' =>'<img src="'.$img.'" class="elchegrabimg">'.$content['text'],
                      'tags_input'=>$content['tags']
                      );
        //print '<em>'.$beforemore.'</em><br>'.$aftermore.'<br><br><br>';

        wp_insert_post($post);

        }
        else
          {
          print '<div class="updated"><p>Новость '.$title.' уже опубликованна</p></div>';
          }






      }


    }
   else
    {
    echo '<div class="updated"><p>Ошибка в обработке RSS!</p></div>';
    }

  }


function elche_grab_get_authorid($a)
  {
   global $wpdb;
   $name=$wpdb->get_results("select * from $wpdb->users where user_nicename='$a'",ARRAY_A);
   return $name[0]['ID'];
  }
function elche_grab_save_img($a)
  {
  $p=get_option('ElcheGrabberImgPatch');
  $fname=basename($a);
  $fbigname=str_replace($fname,'',$a);
  $fbigname.='big_'.$fname;

    if (copy($fbigname,$_SERVER['DOCUMENT_ROOT'].'/wp-content/'.$p.'/'.$fname))
      {
      $surl=get_option('siteurl');
      if ($surl[strlen($surl)]=='/')
        {
         return $surl.'wp-content/'.$p.'/'.$fname;
        }
      else
        {
         return $surl.'/wp-content/'.$p.'/'.$fname;
        }


      }
  }
function elche_grab_get_content($a)
  {
  $text=join('',file($a));
    $ex=explode('<!-- news image and text -->',$text);
    $ex1=explode('<!-- news url -->',$ex[1]);
    $contenet=trim($ex1[0]);
    $contenet=trim(strip_tags($contenet));
         for ($i=200;$i<300;$i++)
          {
          if ($contenet[$i]==' ')
            {
            $b=substr($contenet,0,$i);
            $af=substr($contenet,$i);
            $ret['text']=$b.'<!--more-->'.$af;
            break;
            }
          else
            {
            continue;
            }
          }

  
  
    //$ret['text']=ereg_replace("/".chr(32)."{2,}/",'',$ret['text']);
    //print $ret['text'].'<br><br><br>';
    $ex=explode('<!-- news tags -->',$text);
    $ex1=explode('</div>',$ex[1]);
    $ret['tags']=str_replace('Теги:','',strip_tags($ex1[0]));
    $ex=explode('<!-- news url -->',$text);
    $ex1=explode('</div>',$ex[1]);
    $link=strip_tags($ex1[0]);
    $ret['ist']=trim(str_replace('Источник:','',$link));
    
  return $ret;
  }
function elche_grab_setcron()
  {
  $p=get_option('ElcheGrabberTime');
  if (empty($p))
    {
    $p='hourly';
    }
  wp_schedule_event(time(), $p, 'cron_hourly');
  }
function elche_grab_clearcron_and_settings()
  {
  wp_clear_scheduled_hook('cron_hourly');
  delete_option('ElcheGrabberRssUrl');
  delete_option('ElcheGrabberUserName');
  delete_option('ElcheGrabberCat');
  delete_option('ElcheGrabberTime');
  delete_option('ElcheGrabberImgPatch');
  }
/////////////////////////////////////////////////////////////////////////////

function elche_grab_add_menu()
{
		add_options_page('Elche Grabber', 'Elche Grabber', 8, __FILE__, 'elche_grab_options_page');
}

add_action('admin_menu', 'elche_grab_add_menu');
//register_activation_hook(__FILE__, 'elche_grab_setcron');
register_deactivation_hook(__FILE__, 'elche_grab_clearcron_and_settings');
add_action('cron_hourly', 'elche_grab_check');
?>
